import { OnDestroy, OnInit } from '@angular/core';
import { FormControl, FormGroup, UntypedFormBuilder } from '@angular/forms';
import { AssetDetailQueryDocument, AssetDetailQueryQuery, DataService, LanguageCode, NotificationService, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const ASSET_DETAIL_QUERY: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class AssetDetailComponent extends TypedBaseDetailComponent<typeof AssetDetailQueryDocument, 'asset'> implements OnInit, OnDestroy {
    private notificationService;
    protected dataService: DataService;
    private formBuilder;
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: FormGroup<{
        name: FormControl<string | null>;
        tags: FormControl<string[] | null>;
        customFields: import("@angular/forms").UntypedFormGroup;
    }>;
    constructor(notificationService: NotificationService, dataService: DataService, formBuilder: UntypedFormBuilder);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onAssetChange(event: {
        id: string;
        name: string;
        tags: string[];
    }): void;
    save(): void;
    protected setFormValues(entity: NonNullable<AssetDetailQueryQuery['asset']>, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AssetDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AssetDetailComponent, "vdr-asset-detail", never, {}, {}, never, never, false, never>;
}
