import { OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Asset, BaseListComponent, DataService, GetAssetListQuery, GetAssetListQueryVariables, ItemOf, ModalService, NotificationService, TagFragment } from '@uponcommerce/admin-ui/core';
import { PaginationInstance } from 'ngx-pagination';
import { BehaviorSubject, Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class AssetListComponent extends BaseListComponent<GetAssetListQuery, ItemOf<GetAssetListQuery, 'assets'>, GetAssetListQueryVariables> implements OnInit {
    private notificationService;
    private modalService;
    private dataService;
    searchTerm$: BehaviorSubject<string | undefined>;
    filterByTags$: BehaviorSubject<TagFragment[] | undefined>;
    uploading: boolean;
    allTags$: Observable<TagFragment[]>;
    paginationConfig$: Observable<PaginationInstance>;
    constructor(notificationService: NotificationService, modalService: ModalService, dataService: DataService, router: Router, route: ActivatedRoute);
    ngOnInit(): void;
    filesSelected(files: File[]): void;
    deleteAssets(assets: Asset[]): void;
    private showModalAndDelete;
    static ɵfac: i0.ɵɵFactoryDeclaration<AssetListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AssetListComponent, "vdr-asset-list", never, {}, {}, never, never, false, never>;
}
