import { OnInit } from '@angular/core';
import { UntypedFormControl } from '@angular/forms';
import { DataService, Dialog, GetChannelsQuery, ItemOf, NotificationService } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
type Channel = ItemOf<GetChannelsQuery, 'channels'>;
export declare class AssignProductsToChannelDialogComponent implements OnInit, Dialog<any> {
    private dataService;
    private notificationService;
    selectedChannel: Channel | null | undefined;
    currentChannel: Channel;
    availableChannels: Channel[];
    resolveWith: (result?: any) => void;
    variantsPreview$: Observable<Array<{
        id: string;
        name: string;
        price: number;
        pricePreview: number;
    }>>;
    priceFactorControl: UntypedFormControl;
    selectedChannelIdControl: UntypedFormControl;
    productIds: string[];
    productVariantIds: string[] | undefined;
    currentChannelIds: string[];
    get isProductVariantMode(): boolean;
    constructor(dataService: DataService, notificationService: NotificationService);
    ngOnInit(): void;
    selectChannel(channelIds: string[]): void;
    assign(): void;
    cancel(): void;
    private getTopVariants;
    static ɵfac: i0.ɵɵFactoryDeclaration<AssignProductsToChannelDialogComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AssignProductsToChannelDialogComponent, "vdr-assign-products-to-channel-dialog", never, {}, {}, never, never, false, never>;
}
export {};
