import { OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { UntypedFormControl } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { ConfigurableOperationInput, DataService, GetCollectionContentsQuery } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class CollectionContentsComponent implements OnInit, OnChanges, OnDestroy {
    private route;
    private router;
    private dataService;
    collectionId: string;
    parentId: string;
    inheritFilters: boolean;
    updatedFilters: ConfigurableOperationInput[] | undefined;
    previewUpdatedFilters: boolean;
    headerTemplate: TemplateRef<any>;
    contents$: Observable<NonNullable<GetCollectionContentsQuery['collection']>['productVariants']['items']>;
    contentsTotalItems$: Observable<number>;
    contentsItemsPerPage$: Observable<number>;
    contentsCurrentPage$: Observable<number>;
    filterTermControl: UntypedFormControl;
    isLoading: boolean;
    private collectionIdChange$;
    private parentIdChange$;
    private filterChanges$;
    private inheritFiltersChanges$;
    private refresh$;
    private destroy$;
    constructor(route: ActivatedRoute, router: Router, dataService: DataService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    setContentsPageNumber(page: number): void;
    setContentsItemsPerPage(perPage: number): void;
    refresh(): void;
    private setParam;
    static ɵfac: i0.ɵɵFactoryDeclaration<CollectionContentsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CollectionContentsComponent, "vdr-collection-contents", never, { "collectionId": { "alias": "collectionId"; "required": false; }; "parentId": { "alias": "parentId"; "required": false; }; "inheritFilters": { "alias": "inheritFilters"; "required": false; }; "updatedFilters": { "alias": "updatedFilters"; "required": false; }; "previewUpdatedFilters": { "alias": "previewUpdatedFilters"; "required": false; }; }, {}, ["headerTemplate"], never, false, never>;
}
