import { CdkDrag, CdkDragDrop, CdkDropList, DragDrop, DragRef } from '@angular/cdk/drag-drop';
import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnChanges, OnInit, QueryList, SimpleChanges } from '@angular/core';
import { DataService, DataTable2Component, GetCollectionListQuery, ItemOf, LocalStorageService } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export type CollectionTableItem = ItemOf<GetCollectionListQuery, 'collections'>;
export type CollectionOrderEvent = {
    collectionId: string;
    parentId: string;
    index: number;
};
export declare class CollectionDataTableComponent extends DataTable2Component<CollectionTableItem> implements OnInit, OnChanges, AfterViewInit {
    protected changeDetectorRef: ChangeDetectorRef;
    protected localStorageService: LocalStorageService;
    protected dataService: DataService;
    private dragDrop;
    subCollections: CollectionTableItem[];
    changeOrder: EventEmitter<CollectionOrderEvent>;
    dropList: CdkDropList<{
        depth: number;
        collection: CollectionTableItem;
    }>;
    collectionRowList: QueryList<CdkDrag>;
    dragRefs: DragRef[];
    absoluteIndex: {
        [id: string]: number;
    };
    constructor(changeDetectorRef: ChangeDetectorRef, localStorageService: LocalStorageService, dataService: DataService, dragDrop: DragDrop);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    getSubcollections(item: CollectionTableItem): {
        __typename?: "Collection" | undefined;
        id: string;
        createdAt: any;
        updatedAt: any;
        name: string;
        slug: string;
        position: number;
        isPrivate: boolean;
        parentId: string;
        breadcrumbs: {
            __typename?: "CollectionBreadcrumb" | undefined;
            id: string;
            name: string;
            slug: string;
        }[];
        featuredAsset?: {
            __typename?: "Asset" | undefined;
            id: string;
            createdAt: any;
            updatedAt: any;
            name: string;
            fileSize: number;
            mimeType: string;
            type: import("@uponcommerce/admin-ui/core").AssetType;
            preview: string;
            source: string;
            width: number;
            height: number;
            focalPoint?: {
                __typename?: "Coordinate" | undefined;
                x: number;
                y: number;
            } | null | undefined;
        } | null | undefined;
        children?: {
            __typename?: "Collection" | undefined;
            id: string;
        }[] | null | undefined;
    }[];
    sortPredicate: (index: number, item: CdkDrag<{
        depth: number;
        collection: CollectionTableItem;
    }>) => boolean;
    onDrop(event: CdkDragDrop<{
        depth: number;
        collection: CollectionTableItem;
    }>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CollectionDataTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CollectionDataTableComponent, "vdr-collection-data-table", never, { "subCollections": { "alias": "subCollections"; "required": false; }; }, { "changeOrder": "changeOrder"; }, never, ["vdr-bulk-action-menu"], false, never>;
}
