import { ChangeDetectorRef, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { BaseListComponent, CollectionFilterParameter, CollectionSortParameter, DataService, DataTableService, GetCollectionListQuery, ItemOf, LanguageCode, ModalService, NotificationService, ServerConfigService } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import { CollectionOrderEvent } from '../collection-data-table/collection-data-table.component';
import * as i0 from "@angular/core";
export declare class CollectionListComponent extends BaseListComponent<GetCollectionListQuery, ItemOf<GetCollectionListQuery, 'collections'>> implements OnInit {
    private dataService;
    private notificationService;
    private modalService;
    private serverConfigService;
    private changeDetectorRef;
    private dataTableService;
    activeCollectionId$: Observable<string | null>;
    activeCollectionIndex$: Observable<number>;
    activeCollectionTitle$: Observable<string>;
    subCollections$: Observable<Array<ItemOf<GetCollectionListQuery, 'collections'>>>;
    availableLanguages$: Observable<LanguageCode[]>;
    contentLanguage$: Observable<LanguageCode>;
    expandedIds: string[];
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    readonly filters: import("@uponcommerce/admin-ui/core").DataTableFilterCollection<CollectionFilterParameter>;
    readonly sorts: import("@uponcommerce/admin-ui/core").DataTableSortCollection<CollectionSortParameter, ["createdAt", "updatedAt", "name", "slug", "position"]>;
    constructor(dataService: DataService, notificationService: NotificationService, modalService: ModalService, router: Router, route: ActivatedRoute, serverConfigService: ServerConfigService, changeDetectorRef: ChangeDetectorRef, dataTableService: DataTableService);
    ngOnInit(): void;
    onRearrange(event: CollectionOrderEvent): void;
    deleteCollection(id: string): void;
    closeContents(): void;
    setLanguage(code: LanguageCode): void;
    toggleExpanded(collection: ItemOf<GetCollectionListQuery, 'collections'>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CollectionListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CollectionListComponent, "vdr-collection-list", never, {}, {}, never, never, false, never>;
}
