import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder, UntypedFormArray } from '@angular/forms';
import { DataService, FacetWithValuesFragment, GetFacetDetailDocument, LanguageCode, ModalService, NotificationService, Permission, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const FACET_DETAIL_QUERY: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class FacetDetailComponent extends TypedBaseDetailComponent<typeof GetFacetDetailDocument, 'facet'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    private modalService;
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    readonly customValueFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        facet: import("@angular/forms").FormGroup<{
            code: import("@angular/forms").FormControl<string | null>;
            name: import("@angular/forms").FormControl<string | null>;
            visible: import("@angular/forms").FormControl<boolean | null>;
            customFields: import("@angular/forms").FormGroup<{}>;
        }>;
        values: import("@angular/forms").FormArray<import("@angular/forms").FormControl<{
            id: string;
            name: string;
            code: string;
            customFields: any;
        } | null>>;
    }>;
    values: Array<FacetWithValuesFragment['values'][number] | {
        name: string;
        code: string;
    }>;
    readonly updatePermission: Permission[];
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService, modalService: ModalService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    updateCode(currentCode: string, nameValue: string): void;
    updateValueCode(currentCode: string, nameValue: string, index: number): void;
    customValueFieldIsSet(index: number, name: string): boolean;
    getValuesFormArray(): UntypedFormArray;
    addFacetValue(): void;
    create(): void;
    save(): void;
    deleteFacetValue(facetValueId: string | undefined, index: number): void;
    private showModalAndDelete;
    /**
     * Sets the values of the form on changes to the facet or current language.
     */
    protected setFormValues(facet: FacetWithValuesFragment, languageCode: LanguageCode): void;
    /**
     * Given a facet and the value of the detailForm, this method creates an updated copy of the facet which
     * can then be persisted to the API.
     */
    private getUpdatedFacet;
    /**
     * Given an array of facet values and the values from the detailForm, this method creates a new array
     * which can be persisted to the API via a createFacetValues mutation.
     */
    private getCreatedFacetValues;
    /**
     * Given an array of facet values and the values from the detailForm, this method creates a new array
     * which can be persisted to the API via an updateFacetValues mutation.
     */
    private getUpdatedFacetValues;
    static ɵfac: i0.ɵɵFactoryDeclaration<FacetDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FacetDetailComponent, "vdr-facet-detail", never, {}, {}, never, never, false, never>;
}
