import { OnInit } from '@angular/core';
import { DataService, GetFacetListDocument, GetFacetListQuery, ItemOf, LanguageCode, TypedBaseListComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const FACET_LIST_QUERY: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class FacetListComponent extends TypedBaseListComponent<typeof GetFacetListDocument, 'facets'> implements OnInit {
    protected dataService: DataService;
    readonly initialLimit = 3;
    displayLimit: {
        [id: string]: number;
    };
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    readonly filters: import("@uponcommerce/admin-ui/core").DataTableFilterCollection<import("@uponcommerce/admin-ui/core").FacetFilterParameter>;
    readonly sorts: import("@uponcommerce/admin-ui/core").DataTableSortCollection<import("@uponcommerce/admin-ui/core").FacetSortParameter, ["id", "createdAt", "updatedAt", "name", "code"]>;
    constructor(dataService: DataService);
    toggleDisplayLimit(facet: ItemOf<GetFacetListQuery, 'facets'>): void;
    setLanguage(code: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FacetListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FacetListComponent, "vdr-facet-list", never, {}, {}, never, never, false, never>;
}
