import { OnInit } from '@angular/core';
import { DataService, JobQueueService, ModalService, NotificationService, ProductListQueryDocument, TypedBaseListComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare class ProductListComponent extends TypedBaseListComponent<typeof ProductListQueryDocument, 'products'> implements OnInit {
    protected dataService: DataService;
    private modalService;
    private notificationService;
    private jobQueueService;
    pendingSearchIndexUpdates: number;
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    readonly filters: import("@uponcommerce/admin-ui/core").DataTableFilterCollection<import("@uponcommerce/admin-ui/core").ProductFilterParameter>;
    readonly sorts: import("@uponcommerce/admin-ui/core").DataTableSortCollection<import("@uponcommerce/admin-ui/core").ProductSortParameter, ["name" | "id" | "createdAt" | "updatedAt" | "slug"]>;
    constructor(dataService: DataService, modalService: ModalService, notificationService: NotificationService, jobQueueService: JobQueueService);
    rebuildSearchIndex(): void;
    deleteProduct(productId: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ProductListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ProductListComponent, "vdr-products-list", never, {}, {}, never, never, false, never>;
}
