import { OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { Observable } from 'rxjs';
import { LanguageCode } from '../../common/generated-types';
import { DataService } from '../../data/providers/data.service';
import { AuthService } from '../../providers/auth/auth.service';
import { BreadcrumbService } from '../../providers/breadcrumb/breadcrumb.service';
import { I18nService } from '../../providers/i18n/i18n.service';
import { LocalStorageService } from '../../providers/local-storage/local-storage.service';
import { ModalService } from '../../providers/modal/modal.service';
import * as i0 from "@angular/core";
export declare class AppShellComponent implements OnInit {
    private authService;
    private dataService;
    private router;
    private i18nService;
    private modalService;
    private localStorageService;
    private breadcrumbService;
    userName$: Observable<string>;
    uiLanguageAndLocale$: Observable<[LanguageCode, string | undefined]>;
    availableLanguages: LanguageCode[];
    hideVendureBranding: boolean | undefined;
    pageTitle$: Observable<string>;
    mainNavExpanded$: Observable<boolean>;
    constructor(authService: AuthService, dataService: DataService, router: Router, i18nService: I18nService, modalService: ModalService, localStorageService: LocalStorageService, breadcrumbService: BreadcrumbService);
    ngOnInit(): void;
    selectUiLanguage(): void;
    expandNav(): void;
    collapseNav(): void;
    logOut(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppShellComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppShellComponent, "vdr-app-shell", never, {}, {}, never, never, false, never>;
}
