import { OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { DataService } from '../../data/providers/data.service';
import { HealthCheckService } from '../../providers/health-check/health-check.service';
import { JobQueueService } from '../../providers/job-queue/job-queue.service';
import { NavMenuItem } from '../../providers/nav-builder/nav-builder-types';
import { NavBuilderService } from '../../providers/nav-builder/nav-builder.service';
import * as i0 from "@angular/core";
export declare class BaseNavComponent implements OnInit, OnDestroy {
    protected route: ActivatedRoute;
    protected router: Router;
    navBuilderService: NavBuilderService;
    protected healthCheckService: HealthCheckService;
    protected jobQueueService: JobQueueService;
    protected dataService: DataService;
    constructor(route: ActivatedRoute, router: Router, navBuilderService: NavBuilderService, healthCheckService: HealthCheckService, jobQueueService: JobQueueService, dataService: DataService);
    private userPermissions;
    private subscription;
    shouldDisplayLink(menuItem: Pick<NavMenuItem, 'requiresPermission'>): boolean | undefined;
    ngOnInit(): void;
    ngOnDestroy(): void;
    getRouterLink(item: NavMenuItem): string[] | null;
    private defineNavMenu;
    static ɵfac: i0.ɵɵFactoryDeclaration<BaseNavComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BaseNavComponent, "[vdrBaseNav]", never, {}, {}, never, never, false, never>;
}
