import { Observable } from 'rxjs';
import { BreadcrumbService } from '../../providers/breadcrumb/breadcrumb.service';
import * as i0 from "@angular/core";
/**
 * A breadcrumbs component which reads the route config and any route that has a `data.breadcrumb` property will
 * be displayed in the breadcrumb trail.
 *
 * The `breadcrumb` property can be a string or a function. If a function, it will be passed the route's `data`
 * object (which will include all resolved keys) and any route params, and should return a BreadcrumbValue.
 *
 * See the test config to get an idea of allowable configs for breadcrumbs.
 */
export declare class BreadcrumbComponent {
    private breadcrumbService;
    breadcrumbs$: Observable<Array<{
        link: string | any[];
        label: string;
    }>>;
    parentBreadcrumb$: Observable<{
        link: string | any[];
        label: string;
    } | undefined>;
    private destroy$;
    constructor(breadcrumbService: BreadcrumbService);
    static ɵfac: i0.ɵɵFactoryDeclaration<BreadcrumbComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BreadcrumbComponent, "vdr-breadcrumb", never, {}, {}, never, never, false, never>;
}
