import { PlatformLocation } from '@angular/common';
import { HttpClient } from '@angular/common/http';
import { Title } from '@angular/platform-browser';
import { DataService } from './data/providers/data.service';
import { AlertsService } from './providers/alerts/alerts.service';
import { CustomHttpTranslationLoader } from './providers/i18n/custom-http-loader';
import { I18nService } from './providers/i18n/i18n.service';
import { LocalStorageService } from './providers/local-storage/local-storage.service';
import { NotificationService } from './providers/notification/notification.service';
import * as i0 from "@angular/core";
import * as i1 from "./components/app-shell/app-shell.component";
import * as i2 from "./components/user-menu/user-menu.component";
import * as i3 from "./components/base-nav/base-nav.component";
import * as i4 from "./components/main-nav/main-nav.component";
import * as i5 from "./components/settings-nav/settings-nav.component";
import * as i6 from "./components/breadcrumb/breadcrumb.component";
import * as i7 from "./components/overlay-host/overlay-host.component";
import * as i8 from "./components/notification/notification.component";
import * as i9 from "./components/ui-language-switcher-dialog/ui-language-switcher-dialog.component";
import * as i10 from "./components/channel-switcher/channel-switcher.component";
import * as i11 from "./components/theme-switcher/theme-switcher.component";
import * as i12 from "./components/alerts/alerts.component";
import * as i13 from "@angular/platform-browser";
import * as i14 from "./data/data.module";
import * as i15 from "./shared/shared.module";
import * as i16 from "@angular/platform-browser/animations";
import * as i17 from "@ngx-translate/core";
export declare class CoreModule {
    private i18nService;
    private localStorageService;
    private titleService;
    private alertsService;
    private dataService;
    private notificationService;
    constructor(i18nService: I18nService, localStorageService: LocalStorageService, titleService: Title, alertsService: AlertsService, dataService: DataService, notificationService: NotificationService);
    private initUiLanguages;
    private initUiTitle;
    private initAlerts;
    static ɵfac: i0.ɵɵFactoryDeclaration<CoreModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<CoreModule, [typeof i1.AppShellComponent, typeof i2.UserMenuComponent, typeof i3.BaseNavComponent, typeof i4.MainNavComponent, typeof i5.SettingsNavComponent, typeof i6.BreadcrumbComponent, typeof i7.OverlayHostComponent, typeof i8.NotificationComponent, typeof i9.UiLanguageSwitcherDialogComponent, typeof i10.ChannelSwitcherComponent, typeof i11.ThemeSwitcherComponent, typeof i12.AlertsComponent], [typeof i13.BrowserModule, typeof i14.DataModule, typeof i15.SharedModule, typeof i16.BrowserAnimationsModule, typeof i17.TranslateModule], [typeof i15.SharedModule, typeof i7.OverlayHostComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<CoreModule>;
}
export declare function HttpLoaderFactory(http: HttpClient, location: PlatformLocation): CustomHttpTranslationLoader;
