import * as Codegen from '../../common/generated-types';
import { CurrentUserChannel, LanguageCode } from '../../common/generated-types';
import { BaseDataService } from './base-data.service';
/**
 * Note: local queries all have a fetch-policy of "cache-first" explicitly specified due to:
 * https://github.com/apollographql/apollo-link-state/issues/236
 */
export declare class ClientDataService {
    private baseDataService;
    constructor(baseDataService: BaseDataService);
    startRequest(): import("rxjs").Observable<Codegen.RequestStartedMutation>;
    completeRequest(): import("rxjs").Observable<Codegen.RequestCompletedMutation>;
    getNetworkStatus(): import("@uponcommerce/admin-ui/core").QueryResult<Codegen.GetNetworkStatusQuery, Record<string, any>>;
    loginSuccess(administratorId: string, username: string, activeChannelId: string, channels: CurrentUserChannel[]): import("rxjs").Observable<Codegen.SetAsLoggedInMutation>;
    logOut(): import("rxjs").Observable<unknown>;
    userStatus(): import("@uponcommerce/admin-ui/core").QueryResult<Codegen.GetUserStatusQuery, Record<string, any>>;
    uiState(): import("@uponcommerce/admin-ui/core").QueryResult<Codegen.GetUiStateQuery, Record<string, any>>;
    setUiLanguage(languageCode: LanguageCode, locale?: string): import("rxjs").Observable<Codegen.SetUiLanguageMutation>;
    setUiLocale(locale: string | undefined): import("rxjs").Observable<Codegen.SetUiLocaleMutation>;
    setContentLanguage(languageCode: LanguageCode): import("rxjs").Observable<Codegen.SetContentLanguageMutation>;
    setUiTheme(theme: string): import("rxjs").Observable<Codegen.SetUiThemeMutation>;
    setDisplayUiExtensionPoints(display: boolean): import("rxjs").Observable<Codegen.SetDisplayUiExtensionPointsMutation>;
    setMainNavExpanded(expanded: boolean): import("rxjs").Observable<Codegen.SetMainNavExpandedMutation>;
    setActiveChannel(channelId: string): import("rxjs").Observable<Codegen.SetActiveChannelMutation>;
    updateUserChannels(channels: Codegen.CurrentUserChannelInput[]): import("rxjs").Observable<Codegen.UpdateUserChannelsMutation>;
}
