import { Provider, Type } from '@angular/core';
import { HistoryEntryComponent, HistoryEntryConfig } from './history-entry-component-types';
import * as i0 from "@angular/core";
/**
 * @description
 * Registers a {@link HistoryEntryComponent} for displaying history entries in the Order/Customer
 * history timeline.
 *
 * @since 1.9.0
 * @docsCategory custom-history-entry-components
 */
export declare function registerHistoryEntryComponent(config: HistoryEntryConfig): Provider;
export declare class HistoryEntryComponentService {
    private customEntryComponents;
    registerComponent(config: HistoryEntryConfig): void;
    getComponent(type: string): Type<HistoryEntryComponent> | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<HistoryEntryComponentService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<HistoryEntryComponentService>;
}
