export type DataTableSortOrder = 'ASC' | 'DESC';
export interface DataTableSortOptions<SortInput extends Record<string, DataTableSortOrder>, Name extends keyof SortInput> {
    name: Name;
}
export declare class DataTableSort<SortInput extends Record<string, DataTableSortOrder>> {
    #private;
    private readonly options;
    private onSetValue?;
    constructor(options: DataTableSortOptions<SortInput, any>, onSetValue?: ((name: keyof SortInput, state: DataTableSortOrder | undefined) => void) | undefined);
    get sortOrder(): DataTableSortOrder | undefined;
    get name(): keyof SortInput;
    toggleSortOrder(): void;
    setSortOrder(sortOrder: DataTableSortOrder | undefined): void;
}
