import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { SelectionManager } from '../../../common/utilities/selection-manager';
import { ModalService } from '../../../providers/modal/modal.service';
import { AssetLike } from './asset-gallery.types';
import * as i0 from "@angular/core";
export declare class AssetGalleryComponent implements OnChanges {
    private modalService;
    assets: AssetLike[];
    /**
     * If true, allows multiple assets to be selected by ctrl+clicking.
     */
    multiSelect: boolean;
    canDelete: boolean;
    selectionChange: EventEmitter<{
        __typename?: "Asset" | undefined;
        id: string;
        createdAt: any;
        updatedAt: any;
        name: string;
        fileSize: number;
        mimeType: string;
        type: import("@uponcommerce/admin-ui/core").AssetType;
        preview: string;
        source: string;
        width: number;
        height: number;
        tags: {
            __typename?: "Tag" | undefined;
            id: string;
            value: string;
        }[];
        focalPoint?: {
            __typename?: "Coordinate" | undefined;
            x: number;
            y: number;
        } | null | undefined;
    }[]>;
    deleteAssets: EventEmitter<{
        __typename?: "Asset" | undefined;
        id: string;
        createdAt: any;
        updatedAt: any;
        name: string;
        fileSize: number;
        mimeType: string;
        type: import("@uponcommerce/admin-ui/core").AssetType;
        preview: string;
        source: string;
        width: number;
        height: number;
        tags: {
            __typename?: "Tag" | undefined;
            id: string;
            value: string;
        }[];
        focalPoint?: {
            __typename?: "Coordinate" | undefined;
            x: number;
            y: number;
        } | null | undefined;
    }[]>;
    selectionManager: SelectionManager<{
        __typename?: "Asset" | undefined;
        id: string;
        createdAt: any;
        updatedAt: any;
        name: string;
        fileSize: number;
        mimeType: string;
        type: import("@uponcommerce/admin-ui/core").AssetType;
        preview: string;
        source: string;
        width: number;
        height: number;
        tags: {
            __typename?: "Tag" | undefined;
            id: string;
            value: string;
        }[];
        focalPoint?: {
            __typename?: "Coordinate" | undefined;
            x: number;
            y: number;
        } | null | undefined;
    }>;
    constructor(modalService: ModalService);
    ngOnChanges(changes: SimpleChanges): void;
    toggleSelection(asset: AssetLike, event?: MouseEvent): void;
    selectMultiple(assets: AssetLike[]): void;
    isSelected(asset: AssetLike): boolean;
    lastSelected(): AssetLike;
    previewAsset(asset: AssetLike): void;
    entityInfoClick(event: MouseEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AssetGalleryComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AssetGalleryComponent, "vdr-asset-gallery", never, { "assets": { "alias": "assets"; "required": false; }; "multiSelect": { "alias": "multiSelect"; "required": false; }; "canDelete": { "alias": "canDelete"; "required": false; }; }, { "selectionChange": "selectionChange"; "deleteAssets": "deleteAssets"; }, never, never, false, never>;
}
