import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder, UntypedFormGroup } from '@angular/forms';
import { CustomFieldConfig, UpdateAssetInput } from '../../../common/generated-types';
import { DataService } from '../../../data/providers/data.service';
import { ModalService } from '../../../providers/modal/modal.service';
import { NotificationService } from '../../../providers/notification/notification.service';
import { AssetLike } from '../asset-gallery/asset-gallery.types';
import { Point } from '../focal-point-control/focal-point-control.component';
import * as i0 from "@angular/core";
export type PreviewPreset = 'tiny' | 'thumb' | 'small' | 'medium' | 'large' | '';
export declare class AssetPreviewComponent implements OnInit, OnDestroy {
    private formBuilder;
    private dataService;
    private notificationService;
    private changeDetector;
    private modalService;
    asset: AssetLike;
    editable: boolean;
    customFields: CustomFieldConfig[];
    customFieldsForm: UntypedFormGroup | undefined;
    assetChange: EventEmitter<Omit<UpdateAssetInput, "focalPoint">>;
    editClick: EventEmitter<any>;
    form: import("@angular/forms").FormGroup<{
        name: import("@angular/forms").FormControl<string | null>;
        tags: import("@angular/forms").FormControl<string[] | null>;
    }>;
    size: PreviewPreset;
    width: number;
    height: number;
    centered: boolean;
    settingFocalPoint: boolean;
    lastFocalPoint?: Point;
    private imageElementRef;
    private previewDivRef;
    private subscription;
    private sizePriorToSettingFocalPoint;
    constructor(formBuilder: FormBuilder, dataService: DataService, notificationService: NotificationService, changeDetector: ChangeDetectorRef, modalService: ModalService);
    get fpx(): number | null;
    get fpy(): number | null;
    ngOnInit(): void;
    ngOnDestroy(): void;
    getSourceFileName(): string;
    onImageLoad(): void;
    updateDimensions(): void;
    setFocalPointStart(): void;
    removeFocalPoint(): void;
    onFocalPointChange(point: Point): void;
    setFocalPointCancel(): void;
    setFocalPointEnd(): void;
    manageTags(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AssetPreviewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AssetPreviewComponent, "vdr-asset-preview", never, { "asset": { "alias": "asset"; "required": false; }; "editable": { "alias": "editable"; "required": false; }; "customFields": { "alias": "customFields"; "required": false; }; "customFieldsForm": { "alias": "customFieldsForm"; "required": false; }; }, { "assetChange": "assetChange"; "editClick": "editClick"; }, never, never, false, never>;
}
