import { ChangeDetectorRef, Injector, OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs';
import { SelectionManager } from '../../../common/utilities/selection-manager';
import { DataService } from '../../../data/providers/data.service';
import { BulkActionRegistryService } from '../../../providers/bulk-action-registry/bulk-action-registry.service';
import { BulkAction, BulkActionLocationId } from '../../../providers/bulk-action-registry/bulk-action-types';
import * as i0 from "@angular/core";
export declare class BulkActionMenuComponent<T = any> implements OnInit, OnDestroy {
    private bulkActionRegistryService;
    private injector;
    private route;
    private dataService;
    private changeDetectorRef;
    locationId: BulkActionLocationId;
    selectionManager: SelectionManager<T>;
    hostComponent: any;
    actions$: Observable<Array<BulkAction<T> & {
        display: boolean;
        translationVars: Record<string, string | number>;
    }>>;
    userPermissions: string[];
    private subscription;
    private onClearSelectionFns;
    constructor(bulkActionRegistryService: BulkActionRegistryService, injector: Injector, route: ActivatedRoute, dataService: DataService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    hasPermissions(bulkAction: Pick<BulkAction, 'requiresPermission'>): boolean | undefined;
    actionClick(event: MouseEvent, action: BulkAction): void;
    clearSelection(): void;
    onClearSelection(callback: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BulkActionMenuComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BulkActionMenuComponent<any>, "vdr-bulk-action-menu", never, { "locationId": { "alias": "locationId"; "required": false; }; "selectionManager": { "alias": "selectionManager"; "required": false; }; "hostComponent": { "alias": "hostComponent"; "required": false; }; }, {}, never, never, false, never>;
}
