import { OnInit } from '@angular/core';
import { UntypedFormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { InputComponentConfig } from '../../../common/component-registry-types';
import { CustomFieldConfig, CustomFieldsFragment, LanguageCode } from '../../../common/generated-types';
import { DataService } from '../../../data/providers/data.service';
import { CustomFieldComponentService, CustomFieldEntityName } from '../../../providers/custom-field-component/custom-field-component.service';
import * as i0 from "@angular/core";
/**
 * This component renders the appropriate type of form input control based
 * on the "type" property of the provided CustomFieldConfig.
 */
export declare class CustomFieldControlComponent implements OnInit {
    private dataService;
    private customFieldComponentService;
    entityName: CustomFieldEntityName;
    formGroup: UntypedFormGroup;
    customField: CustomFieldsFragment;
    compact: boolean;
    showLabel: boolean;
    readonly: boolean;
    hasCustomControl: boolean;
    private customComponentPlaceholder;
    private customComponentFactory;
    uiLanguage$: Observable<LanguageCode>;
    constructor(dataService: DataService, customFieldComponentService: CustomFieldComponentService);
    ngOnInit(): void;
    getFieldDefinition(): CustomFieldConfig & {
        ui?: InputComponentConfig;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<CustomFieldControlComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CustomFieldControlComponent, "vdr-custom-field-control", never, { "entityName": { "alias": "entityName"; "required": false; }; "formGroup": { "alias": "customFieldsFormGroup"; "required": false; }; "customField": { "alias": "customField"; "required": false; }; "compact": { "alias": "compact"; "required": false; }; "showLabel": { "alias": "showLabel"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; }, {}, never, never, false, never>;
}
