import dayjs from 'dayjs';
import { Observable } from 'rxjs';
import { CalendarView, DayOfWeek } from './types';
import * as i0 from "@angular/core";
export declare class DatetimePickerService {
    calendarView$: Observable<CalendarView>;
    selected$: Observable<Date | null>;
    viewing$: Observable<Date>;
    private selectedDatetime$;
    private viewingDatetime$;
    private weekStartDayIndex;
    private min;
    private max;
    private jumping;
    constructor();
    setWeekStartingDay(weekStartDay: DayOfWeek): void;
    setMin(min?: string | null): void;
    setMax(max?: string | null): void;
    selectDatetime(date: Date | string | dayjs.Dayjs | null): void;
    selectHour(hourOfDay: number): void;
    selectMinute(minutePastHour: number): void;
    viewNextMonth(): void;
    viewPrevMonth(): void;
    viewToday(): void;
    viewJumpDown(): void;
    viewJumpUp(): void;
    viewJumpRight(): void;
    viewJumpLeft(): void;
    selectToday(): void;
    selectViewed(): void;
    viewMonth(month: number): void;
    viewYear(year: number): void;
    private generateCalendarView;
    private isInBounds;
    static ɵfac: i0.ɵɵFactoryDeclaration<DatetimePickerService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DatetimePickerService>;
}
