import { OnChanges } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * This component displays a plain JavaScript object as an expandable tree.
 *
 * @example
 * ```HTML
 * <vdr-object-tree [value]="payment.metadata"></vdr-object-tree>
 * ```
 *
 * @docsCategory components
 */
export declare class ObjectTreeComponent implements OnChanges {
    value: {
        [key: string]: any;
    } | string;
    isArrayItem: boolean;
    depth: number;
    expanded: boolean;
    valueIsArray: boolean;
    entries: Array<{
        key: string;
        value: any;
    }>;
    constructor(parent: ObjectTreeComponent);
    ngOnChanges(): void;
    isObject(value: any): boolean;
    private getEntries;
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectTreeComponent, [{ optional: true; skipSelf: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ObjectTreeComponent, "vdr-object-tree", never, { "value": { "alias": "value"; "required": false; }; "isArrayItem": { "alias": "isArrayItem"; "required": false; }; }, {}, never, never, false, never>;
}
