import { AfterContentInit, AfterViewInit, ElementRef, EventEmitter, TemplateRef, ViewContainerRef } from '@angular/core';
import { DomSanitizer, SafeStyle } from '@angular/platform-browser';
import { Observable } from 'rxjs';
import { SplitViewRightDirective } from './split-view.directive';
import * as i0 from "@angular/core";
export declare class SplitViewComponent implements AfterContentInit, AfterViewInit {
    private viewContainerRef;
    private domSanitizer;
    rightPanelOpen: boolean;
    closeClicked: EventEmitter<void>;
    leftTemplate: TemplateRef<any>;
    rightTemplate: SplitViewRightDirective;
    resizeHandle: ElementRef<HTMLDivElement>;
    protected rightPanelWidth$: Observable<number>;
    protected leftPanelWidth$: Observable<SafeStyle>;
    protected resizing$: Observable<boolean>;
    constructor(viewContainerRef: ViewContainerRef, domSanitizer: DomSanitizer);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    close(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SplitViewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SplitViewComponent, "vdr-split-view", never, { "rightPanelOpen": { "alias": "rightPanelOpen"; "required": false; }; }, { "closeClicked": "closeClicked"; }, ["leftTemplate", "rightTemplate"], never, false, never>;
}
