import { AfterViewInit, ChangeDetectorRef } from '@angular/core';
import { UntypedFormControl, ValidatorFn } from '@angular/forms';
import { DefaultFormComponentConfig } from '@uponcommerce/common/lib/shared-types';
import { CodeJar } from 'codejar';
import { FormInputComponent } from '../../../common/component-registry-types';
import * as i0 from "@angular/core";
export interface CodeEditorConfig {
    validator: ValidatorFn;
    getErrorMessage: (content: string) => string | undefined;
    highlight: (content: string, errorPos: number | undefined) => string;
}
export declare abstract class BaseCodeEditorFormInputComponent implements FormInputComponent, AfterViewInit {
    protected changeDetector: ChangeDetectorRef;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'json-editor-form-input'>;
    isValid: boolean;
    errorMessage: string | undefined;
    private editorElementRef;
    jar: CodeJar;
    private highlight;
    private getErrorMessage;
    protected constructor(changeDetector: ChangeDetectorRef);
    get height(): string | undefined;
    configure(config: CodeEditorConfig): void;
    ngAfterViewInit(): void;
    protected getErrorPos(errorMessage: string | undefined): number | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<BaseCodeEditorFormInputComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BaseCodeEditorFormInputComponent, never, never, {}, {}, never, never, false, never>;
}
