import { AfterViewInit, ChangeDetectorRef, OnInit } from '@angular/core';
import { DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import { BaseCodeEditorFormInputComponent } from './base-code-editor-form-input.component';
import * as i0 from "@angular/core";
/**
 * @description
 * A JSON editor input with syntax highlighting and error detection. Works well
 * with `text` type fields.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class HtmlEditorFormInputComponent extends BaseCodeEditorFormInputComponent implements FormInputComponent, AfterViewInit, OnInit {
    protected changeDetector: ChangeDetectorRef;
    static readonly id: DefaultFormComponentId;
    constructor(changeDetector: ChangeDetectorRef);
    ngOnInit(): void;
    private encodeHtmlChars;
    static ɵfac: i0.ɵɵFactoryDeclaration<HtmlEditorFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<HtmlEditorFormInputComponent, "vdr-html-editor-form-input", never, {}, {}, never, never, false, never>;
}
