import { OnInit } from '@angular/core';
import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentConfig, DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { Observable } from 'rxjs';
import { FormInputComponent } from '../../../common/component-registry-types';
import { ConfigurableInputComponent } from '../../components/configurable-input/configurable-input.component';
import * as i0 from "@angular/core";
/**
 * @description
 * A special input used to display the "Combination mode" AND/OR toggle.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class CombinationModeFormInputComponent implements FormInputComponent, OnInit {
    private configurableInputComponent;
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'combination-mode-form-input'>;
    selectable$: Observable<boolean>;
    constructor(configurableInputComponent: ConfigurableInputComponent);
    ngOnInit(): void;
    setCombinationModeAnd(): void;
    setCombinationModeOr(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CombinationModeFormInputComponent, [{ optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CombinationModeFormInputComponent, "vdr-combination-mode-form-input", never, {}, {}, never, never, false, never>;
}
