import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentConfig, DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import * as i0 from "@angular/core";
/**
 * @description
 * Allows selection of a datetime. Default input for `datetime` type fields.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class DateFormInputComponent implements FormInputComponent {
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'date-form-input'>;
    get min(): string | undefined;
    get max(): string | undefined;
    get yearRange(): number | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<DateFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DateFormInputComponent, "vdr-date-form-input", never, { "readonly": { "alias": "readonly"; "required": false; }; }, {}, never, never, false, never>;
}
