import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentConfig, DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import * as i0 from "@angular/core";
/**
 * @description
 * Displays a number input. Default input for `int` and `float` type fields.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class NumberFormInputComponent implements FormInputComponent {
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'number-form-input'>;
    get prefix(): string | undefined;
    get suffix(): string | undefined;
    get min(): number | undefined;
    get max(): number | undefined;
    get step(): number | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<NumberFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NumberFormInputComponent, "vdr-number-form-input", never, { "readonly": { "alias": "readonly"; "required": false; }; }, {}, never, never, false, never>;
}
