import { OnInit } from '@angular/core';
import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { Observable } from 'rxjs';
import { FormInputComponent } from '../../../../common/component-registry-types';
import { GetAssetQuery, RelationCustomFieldConfig } from '../../../../common/generated-types';
import { DataService } from '../../../../data/providers/data.service';
import { ModalService } from '../../../../providers/modal/modal.service';
import * as i0 from "@angular/core";
export declare const RELATION_ASSET_INPUT_QUERY: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class RelationAssetInputComponent implements FormInputComponent, OnInit {
    private modalService;
    private dataService;
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: RelationCustomFieldConfig;
    asset$: Observable<GetAssetQuery['asset'] | undefined>;
    constructor(modalService: ModalService, dataService: DataService);
    ngOnInit(): void;
    selectAsset(): void;
    remove(): void;
    previewAsset(asset: NonNullable<GetAssetQuery['asset']>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<RelationAssetInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RelationAssetInputComponent, "vdr-relation-asset-input", never, { "readonly": { "alias": "readonly"; "required": false; }; "formControl": { "alias": "parentFormControl"; "required": false; }; "config": { "alias": "config"; "required": false; }; }, {}, never, never, false, never>;
}
