import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import { RelationCustomFieldConfig } from '../../../common/generated-types';
import * as i0 from "@angular/core";
/**
 * @description
 * The default input component for `relation` type custom fields. Allows the selection
 * of a ProductVariant, Product, Customer or Asset. For other entity types, a custom
 * implementation will need to be defined. See {@link registerFormInputComponent}.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class RelationFormInputComponent implements FormInputComponent {
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: RelationCustomFieldConfig;
    static ɵfac: i0.ɵɵFactoryDeclaration<RelationFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RelationFormInputComponent, "vdr-relation-form-input", never, { "readonly": { "alias": "readonly"; "required": false; }; }, {}, never, never, false, never>;
}
