import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentConfig, DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import * as i0 from "@angular/core";
/**
 * @description
 * Uses the {@link RichTextEditorComponent} as in input for `text` type fields.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class RichTextFormInputComponent implements FormInputComponent {
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'rich-text-form-input'>;
    static ɵfac: i0.ɵɵFactoryDeclaration<RichTextFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RichTextFormInputComponent, "vdr-rich-text-form-input", never, {}, {}, never, never, false, never>;
}
