import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentConfig, DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import * as i0 from "@angular/core";
/**
 * @description
 * Uses a regular text form input. This is the default input for `string` and `localeString` type fields.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class TextFormInputComponent implements FormInputComponent {
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'text-form-input'>;
    get prefix(): string | undefined;
    get suffix(): string | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TextFormInputComponent, "vdr-text-form-input", never, {}, {}, never, never, false, never>;
}
