import { UntypedFormControl } from '@angular/forms';
import { DefaultFormComponentConfig, DefaultFormComponentId } from '@uponcommerce/common/lib/shared-types';
import { FormInputComponent } from '../../../common/component-registry-types';
import * as i0 from "@angular/core";
/**
 * @description
 * Uses textarea form input. This is the default input for `text` type fields.
 *
 * @docsCategory custom-input-components
 * @docsPage default-inputs
 */
export declare class TextareaFormInputComponent implements FormInputComponent {
    static readonly id: DefaultFormComponentId;
    readonly: boolean;
    formControl: UntypedFormControl;
    config: DefaultFormComponentConfig<'textarea-form-input'>;
    get spellcheck(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextareaFormInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TextareaFormInputComponent, "vdr-textarea-form-input", never, {}, {}, never, never, false, never>;
}
