import { PipeTransform } from '@angular/core';
import { I18nService } from '../../providers/i18n/i18n.service';
import * as i0 from "@angular/core";
/**
 * @description
 * Displays a number of milliseconds in a more human-readable format,
 * e.g. "12ms", "33s", "2:03m"
 *
 * @example
 * ```TypeScript
 * {{ timeInMs | duration }}
 * ```
 *
 * @docsCategory pipes
 */
export declare class DurationPipe implements PipeTransform {
    private i18nService;
    constructor(i18nService: I18nService);
    transform(value: number): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<DurationPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<DurationPipe, "duration", false>;
}
