import { ChangeDetectorRef, PipeTransform } from '@angular/core';
import { DataService } from '../../data/providers/data.service';
import { LocaleBasePipe } from './locale-base.pipe';
import * as i0 from "@angular/core";
/**
 * @description
 * A replacement of the Angular DatePipe which makes use of the Intl API
 * to format dates according to the selected UI language.
 *
 * @example
 * ```HTML
 * {{ order.orderPlacedAt | localeDate }}
 * ```
 *
 * @docsCategory pipes
 */
export declare class LocaleDatePipe extends LocaleBasePipe implements PipeTransform {
    constructor(dataService?: DataService, changeDetectorRef?: ChangeDetectorRef);
    transform(value: unknown, ...args: unknown[]): unknown;
    private getOptionsForFormat;
    static ɵfac: i0.ɵɵFactoryDeclaration<LocaleDatePipe, [{ optional: true; }, { optional: true; }]>;
    static ɵpipe: i0.ɵɵPipeDeclaration<LocaleDatePipe, "localeDate", false>;
}
