import { ChangeDetectorRef, PipeTransform } from '@angular/core';
import { DataService } from '../../data/providers/data.service';
import { LocaleBasePipe } from './locale-base.pipe';
import * as i0 from "@angular/core";
/**
 * @description
 * Displays a human-readable name for a given region.
 *
 * @example
 * ```HTML
 * {{ 'GB' | localeRegionName }}
 * ```
 *
 * @docsCategory pipes
 */
export declare class LocaleRegionNamePipe extends LocaleBasePipe implements PipeTransform {
    constructor(dataService?: DataService, changeDetectorRef?: ChangeDetectorRef);
    transform(value: any, locale?: unknown): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<LocaleRegionNamePipe, [{ optional: true; }, { optional: true; }]>;
    static ɵpipe: i0.ɵɵPipeDeclaration<LocaleRegionNamePipe, "localeRegionName", false>;
}
