import { ChangeDetectorRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { UntypedFormGroup } from '@angular/forms';
import { CustomFieldConfig, GetAvailableCountriesQuery, ModalService } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare class AddressCardComponent implements OnInit, OnChanges {
    private modalService;
    private changeDetector;
    addressForm: UntypedFormGroup;
    customFields: CustomFieldConfig;
    availableCountries: GetAvailableCountriesQuery['countries']['items'];
    isDefaultBilling: string;
    isDefaultShipping: string;
    editable: boolean;
    setAsDefaultShipping: EventEmitter<string>;
    setAsDefaultBilling: EventEmitter<string>;
    deleteAddress: EventEmitter<string>;
    private dataDependenciesPopulated;
    constructor(modalService: ModalService, changeDetector: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    getCountryName(countryCode: string): string;
    setAsDefaultBillingAddress(): void;
    setAsDefaultShippingAddress(): void;
    delete(): void;
    editAddress(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AddressCardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AddressCardComponent, "vdr-address-card", never, { "addressForm": { "alias": "addressForm"; "required": false; }; "customFields": { "alias": "customFields"; "required": false; }; "availableCountries": { "alias": "availableCountries"; "required": false; }; "isDefaultBilling": { "alias": "isDefaultBilling"; "required": false; }; "isDefaultShipping": { "alias": "isDefaultShipping"; "required": false; }; "editable": { "alias": "editable"; "required": false; }; }, { "setAsDefaultShipping": "setAsDefaultShipping"; "setAsDefaultBilling": "setAsDefaultBilling"; "deleteAddress": "deleteAddress"; }, never, never, false, never>;
}
