import { OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { ResultOf } from '@graphql-typed-document-node/core';
import { DataService, GetCustomerGroupDetailDocument, ModalService, NotificationService, ServerConfigService, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const CUSTOMER_GROUP_DETAIL_QUERY: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class CustomerGroupDetailComponent extends TypedBaseDetailComponent<typeof GetCustomerGroupDetailDocument, 'customerGroup'> implements OnInit {
    private formBuilder;
    protected dataService: DataService;
    private modalService;
    private notificationService;
    customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        name: import("@angular/forms").FormControl<string | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    constructor(route: ActivatedRoute, router: Router, serverConfigService: ServerConfigService, formBuilder: FormBuilder, dataService: DataService, modalService: ModalService, notificationService: NotificationService);
    ngOnInit(): void;
    create(): void;
    save(): void;
    protected setFormValues(entity: NonNullable<ResultOf<typeof GetCustomerGroupDetailDocument>['customerGroup']>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CustomerGroupDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CustomerGroupDetailComponent, "vdr-customer-group-detail", never, {}, {}, never, never, false, never>;
}
