import { OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { DataService, GetCustomerGroupListDocument, GetCustomerGroupsQuery, GetCustomerGroupWithCustomersQuery, ItemOf, ModalService, NotificationService, TypedBaseListComponent } from '@uponcommerce/admin-ui/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { CustomerGroupMemberFetchParams } from '../customer-group-member-list/customer-group-member-list.component';
import * as i0 from "@angular/core";
export declare const GET_CUSTOMER_GROUP_LIST: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class CustomerGroupListComponent extends TypedBaseListComponent<typeof GetCustomerGroupListDocument, 'customerGroups'> implements OnInit {
    protected dataService: DataService;
    private notificationService;
    private modalService;
    route: ActivatedRoute;
    protected router: Router;
    activeGroup$: Observable<ItemOf<GetCustomerGroupsQuery, 'customerGroups'> | undefined>;
    activeIndex$: Observable<number>;
    listIsEmpty$: Observable<boolean>;
    members$: Observable<NonNullable<GetCustomerGroupWithCustomersQuery['customerGroup']>['customers']['items']>;
    membersTotal$: Observable<number>;
    fetchGroupMembers$: BehaviorSubject<CustomerGroupMemberFetchParams>;
    readonly filters: import("@uponcommerce/admin-ui/core").DataTableFilterCollection<import("@uponcommerce/admin-ui/core").CustomerGroupFilterParameter>;
    readonly sorts: import("@uponcommerce/admin-ui/core").DataTableSortCollection<import("@uponcommerce/admin-ui/core").CustomerGroupSortParameter, ["createdAt", "updatedAt", "name"]>;
    private refreshActiveGroupMembers$;
    constructor(dataService: DataService, notificationService: NotificationService, modalService: ModalService, route: ActivatedRoute, router: Router);
    ngOnInit(): void;
    closeMembers(): void;
    addToGroup(group: NonNullable<GetCustomerGroupWithCustomersQuery['customerGroup']>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CustomerGroupListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CustomerGroupListComponent, "vdr-customer-group-list", never, {}, {}, never, never, false, never>;
}
