import { OnInit } from '@angular/core';
import { CustomFieldConfig, Dialog, ModifyOrderInput, OrderDetailFragment } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare enum OrderEditResultType {
    Refund = 0,
    Payment = 1,
    PriceUnchanged = 2,
    Cancel = 3
}
interface OrderEditsRefundResult {
    result: OrderEditResultType.Refund;
    refundPaymentId: string;
    refundNote?: string;
}
interface OrderEditsPaymentResult {
    result: OrderEditResultType.Payment;
}
interface OrderEditsPriceUnchangedResult {
    result: OrderEditResultType.PriceUnchanged;
}
interface OrderEditsCancelResult {
    result: OrderEditResultType.Cancel;
}
type OrderEditResult = OrderEditsRefundResult | OrderEditsPaymentResult | OrderEditsPriceUnchangedResult | OrderEditsCancelResult;
export declare class OrderEditsPreviewDialogComponent implements OnInit, Dialog<OrderEditResult> {
    order: OrderDetailFragment;
    originalTotalWithTax: number;
    orderLineCustomFields: CustomFieldConfig[];
    modifyOrderInput: ModifyOrderInput;
    selectedPayment?: NonNullable<OrderDetailFragment['payments']>[number];
    refundNote: string;
    resolveWith: (result?: OrderEditResult) => void;
    get priceDifference(): number;
    ngOnInit(): void;
    cancel(): void;
    submit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<OrderEditsPreviewDialogComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OrderEditsPreviewDialogComponent, "vdr-order-edits-preview-dialog", never, {}, {}, never, never, false, never>;
}
export {};
