import { OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { BaseListComponent, ChannelService, DataService, DataTableService, GetOrderListQuery, ItemOf, LocalStorageService, NavBuilderService, OrderFilterParameter, OrderSortParameter, ServerConfigService } from '@uponcommerce/admin-ui/core';
import { Order } from '@uponcommerce/common/lib/generated-types';
import * as i0 from "@angular/core";
export declare class OrderListComponent extends BaseListComponent<GetOrderListQuery, ItemOf<GetOrderListQuery, 'orders'>> implements OnInit {
    private serverConfigService;
    private dataService;
    private localStorageService;
    private channelService;
    private dataTableService;
    orderStates: string[];
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    readonly filters: import("@uponcommerce/admin-ui/core").DataTableFilterCollection<OrderFilterParameter>;
    readonly sorts: import("@uponcommerce/admin-ui/core").DataTableSortCollection<OrderSortParameter, ["id", "createdAt", "updatedAt", "orderPlacedAt", "customerLastName", "state", "totalWithTax"]>;
    canCreateDraftOrder: boolean;
    private activeChannelIsDefaultChannel;
    constructor(serverConfigService: ServerConfigService, dataService: DataService, localStorageService: LocalStorageService, channelService: ChannelService, dataTableService: DataTableService, navBuilderService: NavBuilderService, router: Router, route: ActivatedRoute);
    ngOnInit(): void;
    private createQueryOptions;
    getShippingNames(order: Order): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<OrderListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OrderListComponent, "vdr-order-list", never, {}, {}, never, never, false, never>;
}
