import { EventEmitter, OnInit } from '@angular/core';
import { UntypedFormGroup } from '@angular/forms';
import { AdjustmentType, CustomFieldConfig, OrderDetailFragment } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare class OrderTableComponent implements OnInit {
    order: OrderDetailFragment;
    orderLineCustomFields: CustomFieldConfig[];
    isDraft: boolean;
    adjust: EventEmitter<{
        lineId: string;
        quantity: number;
    }>;
    remove: EventEmitter<{
        lineId: string;
    }>;
    orderLineCustomFieldsVisible: boolean;
    customFieldsForLine: {
        [lineId: string]: Array<{
            config: CustomFieldConfig;
            formGroup: UntypedFormGroup;
            value: any;
        }>;
    };
    get visibleOrderLineCustomFields(): CustomFieldConfig[];
    get showElided(): boolean;
    ngOnInit(): void;
    draftInputBlur(line: OrderDetailFragment['lines'][number], quantity: number): void;
    toggleOrderLineCustomFields(): void;
    getLineDiscounts(line: OrderDetailFragment['lines'][number]): {
        __typename?: "Discount" | undefined;
        adjustmentSource: string;
        amount: number;
        amountWithTax: number;
        description: string;
        type: AdjustmentType;
    }[];
    private getLineCustomFields;
    getPromotionLink(promotion: OrderDetailFragment['discounts'][number]): any[];
    getCouponCodeForAdjustment(order: OrderDetailFragment, promotionAdjustment: OrderDetailFragment['discounts'][number]): string | undefined;
    getShippingNames(order: OrderDetailFragment): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<OrderTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OrderTableComponent, "vdr-order-table", never, { "order": { "alias": "order"; "required": false; }; "orderLineCustomFields": { "alias": "orderLineCustomFields"; "required": false; }; "isDraft": { "alias": "isDraft"; "required": false; }; }, { "adjust": "adjust"; "remove": "remove"; }, never, never, false, never>;
}
