import { OnInit } from '@angular/core';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { AddressFragment, CreateAddressInput, DataService, Dialog, GetAvailableCountriesQuery, OrderAddressFragment } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import { Customer } from '../select-customer-dialog/select-customer-dialog.component';
import * as i0 from "@angular/core";
export declare class SelectAddressDialogComponent implements OnInit, Dialog<CreateAddressInput> {
    private dataService;
    private formBuilder;
    resolveWith: (result?: CreateAddressInput) => void;
    availableCountries$: Observable<GetAvailableCountriesQuery['countries']['items']>;
    addresses$: Observable<AddressFragment[]>;
    customerId: string | undefined;
    currentAddress: OrderAddressFragment | undefined;
    addressForm: UntypedFormGroup;
    selectedAddress: AddressFragment | undefined;
    useExisting: boolean;
    createNew: boolean;
    constructor(dataService: DataService, formBuilder: UntypedFormBuilder);
    ngOnInit(): void;
    trackByFn(item: Customer): string;
    addressIdFn(item: AddressFragment): string;
    cancel(): void;
    select(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectAddressDialogComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectAddressDialogComponent, "vdr-select-address-dialog", never, {}, {}, never, never, false, never>;
}
