import { OnInit } from '@angular/core';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { CreateCustomerInput, DataService, Dialog, GetCustomerListQuery } from '@uponcommerce/admin-ui/core';
import { Observable, Subject } from 'rxjs';
import * as i0 from "@angular/core";
export type Customer = GetCustomerListQuery['customers']['items'][number];
export declare class SelectCustomerDialogComponent implements OnInit, Dialog<Customer | CreateCustomerInput> {
    private dataService;
    private formBuilder;
    resolveWith: (result?: Customer | CreateCustomerInput) => void;
    customerForm: UntypedFormGroup;
    customers$: Observable<Customer[]>;
    isLoading: boolean;
    input$: Subject<string>;
    selectedCustomer: Customer[];
    useExisting: boolean;
    createNew: boolean;
    constructor(dataService: DataService, formBuilder: UntypedFormBuilder);
    ngOnInit(): void;
    trackByFn(item: Customer): string;
    cancel(): void;
    select(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectCustomerDialogComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectCustomerDialogComponent, "vdr-select-customer-dialog", never, {}, {}, never, never, false, never>;
}
