import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { CountryFragment, DataService, GetCountryDetailDocument, LanguageCode, NotificationService, Permission, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const GET_COUNTRY_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class CountryDetailComponent extends TypedBaseDetailComponent<typeof GetCountryDetailDocument, 'country'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        code: import("@angular/forms").FormControl<string | null>;
        name: import("@angular/forms").FormControl<string | null>;
        enabled: import("@angular/forms").FormControl<boolean | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    readonly updatePermission: Permission[];
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    create(): void;
    save(): void;
    protected setFormValues(country: CountryFragment, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CountryDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CountryDetailComponent, "vdr-country-detail", never, {}, {}, never, never, false, never>;
}
