import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ConfigurableOperation, ConfigurableOperationDefinition, DataService, GetPaymentMethodDetailDocument, GetPaymentMethodDetailQuery, LanguageCode, NotificationService, Permission, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const GET_PAYMENT_METHOD_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class PaymentMethodDetailComponent extends TypedBaseDetailComponent<typeof GetPaymentMethodDetailDocument, 'paymentMethod'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        code: import("@angular/forms").FormControl<string | null>;
        name: import("@angular/forms").FormControl<string | null>;
        description: import("@angular/forms").FormControl<string | null>;
        enabled: import("@angular/forms").FormControl<boolean | null>;
        checker: import("@angular/forms").FormControl<{
            __typename?: "ConfigurableOperation" | undefined;
            code: string;
            args: {
                __typename?: "ConfigArg" | undefined;
                name: string;
                value: string;
            }[];
        } | null | undefined>;
        handler: import("@angular/forms").FormControl<{
            __typename?: "ConfigurableOperation" | undefined;
            code: string;
            args: {
                __typename?: "ConfigArg" | undefined;
                name: string;
                value: string;
            }[];
        } | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    checkers: ConfigurableOperationDefinition[];
    handlers: ConfigurableOperationDefinition[];
    selectedChecker?: ConfigurableOperation | null;
    selectedCheckerDefinition?: ConfigurableOperationDefinition;
    selectedHandler?: ConfigurableOperation | null;
    selectedHandlerDefinition?: ConfigurableOperationDefinition;
    readonly updatePermission: Permission[];
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    updateCode(currentCode: string | undefined, nameValue: string): void;
    selectChecker(checker: ConfigurableOperationDefinition): void;
    selectHandler(handler: ConfigurableOperationDefinition): void;
    removeChecker(): void;
    removeHandler(): void;
    create(): void;
    save(): void;
    /**
     * Given a PaymentMethod and the value of the detailForm, this method creates an updated copy of it which
     * can then be persisted to the API.
     */
    private getUpdatedPaymentMethod;
    protected setFormValues(paymentMethod: NonNullable<GetPaymentMethodDetailQuery['paymentMethod']>, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PaymentMethodDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PaymentMethodDetailComponent, "vdr-payment-method-detail", never, {}, {}, never, never, false, never>;
}
