import { EventEmitter, OnInit } from '@angular/core';
import { PermissionDefinition } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export interface PermissionGridRow {
    label: string;
    description: string;
    permissions: PermissionDefinition[];
}
/**
 * A table showing and allowing the setting of all possible CRUD permissions.
 */
export declare class PermissionGridComponent implements OnInit {
    permissionDefinitions: PermissionDefinition[];
    activePermissions: string[];
    readonly: boolean;
    permissionChange: EventEmitter<{
        permission: string;
        value: boolean;
    }>;
    gridData: PermissionGridRow[];
    ngOnInit(): void;
    setPermission(permission: string, value: boolean): void;
    toggleAll(defs: PermissionDefinition[]): void;
    private buildGrid;
    private extractCrudDescription;
    static ɵfac: i0.ɵɵFactoryDeclaration<PermissionGridComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PermissionGridComponent, "vdr-permission-grid", never, { "permissionDefinitions": { "alias": "permissionDefinitions"; "required": false; }; "activePermissions": { "alias": "activePermissions"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; }, { "permissionChange": "permissionChange"; }, never, never, false, never>;
}
