import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Administrator, DataService, GetProfileDetailDocument, LanguageCode, NotificationService, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const GET_PROFILE_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class ProfileComponent extends TypedBaseDetailComponent<typeof GetProfileDetailDocument, 'activeAdministrator'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        emailAddress: import("@angular/forms").FormControl<string | null>;
        firstName: import("@angular/forms").FormControl<string | null>;
        lastName: import("@angular/forms").FormControl<string | null>;
        password: import("@angular/forms").FormControl<string | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    save(): void;
    protected setFormValues(administrator: Administrator, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ProfileComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ProfileComponent, "vdr-profile", never, {}, {}, never, never, false, never>;
}
