import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { DataService, GetRoleDetailDocument, LanguageCode, NotificationService, Permission, Role, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const GET_ROLE_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class RoleDetailComponent extends TypedBaseDetailComponent<typeof GetRoleDetailDocument, 'role'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    detailForm: import("@angular/forms").FormGroup<{
        code: import("@angular/forms").FormControl<string | null>;
        description: import("@angular/forms").FormControl<string | null>;
        channelIds: import("@angular/forms").FormControl<string[] | null>;
        permissions: import("@angular/forms").FormControl<Permission[] | null>;
    }>;
    permissionDefinitions: import("@uponcommerce/admin-ui/core").PermissionDefinition[];
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    updateCode(nameValue: string): void;
    setPermission(change: {
        permission: string;
        value: boolean;
    }): void;
    create(): void;
    save(): void;
    protected setFormValues(role: Role, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<RoleDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RoleDetailComponent, "vdr-role-detail", never, {}, {}, never, never, false, never>;
}
