import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { CustomFieldConfig, DataService, GetSellerDetailDocument, LanguageCode, NotificationService, Permission, SellerFragment, ServerConfigService, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const GET_SELLER_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class SellerDetailComponent extends TypedBaseDetailComponent<typeof GetSellerDetailDocument, 'seller'> implements OnInit, OnDestroy {
    protected serverConfigService: ServerConfigService;
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    customFields: CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        name: import("@angular/forms").FormControl<string | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    readonly updatePermission: Permission[];
    constructor(router: Router, route: ActivatedRoute, serverConfigService: ServerConfigService, changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    saveButtonEnabled(): boolean;
    create(): void;
    save(): void;
    /**
     * Update the form values when the entity changes.
     */
    protected setFormValues(entity: SellerFragment, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SellerDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SellerDetailComponent, "vdr-seller-detail", never, {}, {}, never, never, false, never>;
}
