import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { DataService, GetTaxCategoryDetailDocument, LanguageCode, NotificationService, Permission, TaxCategoryFragment, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
export declare const GET_TAX_CATEGORY_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class TaxCategoryDetailComponent extends TypedBaseDetailComponent<typeof GetTaxCategoryDetailDocument, 'taxCategory'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        name: import("@angular/forms").FormControl<string | null>;
        isDefault: import("@angular/forms").FormControl<boolean | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    readonly updatePermission: Permission[];
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    saveButtonEnabled(): boolean;
    create(): void;
    save(): void;
    /**
     * Update the form values when the entity changes.
     */
    protected setFormValues(entity: TaxCategoryFragment, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaxCategoryDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TaxCategoryDetailComponent, "vdr-tax-detail", never, {}, {}, never, never, false, never>;
}
