import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { CustomerGroup, CustomFieldConfig, DataService, GetTaxRateDetailDocument, LanguageCode, NotificationService, Permission, TaxCategoryFragment, TaxRateFragment, TypedBaseDetailComponent } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare const GET_TAX_RATE_DETAIL: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class TaxRateDetailComponent extends TypedBaseDetailComponent<typeof GetTaxRateDetailDocument, 'taxRate'> implements OnInit, OnDestroy {
    private changeDetector;
    protected dataService: DataService;
    private formBuilder;
    private notificationService;
    customFields: CustomFieldConfig[];
    detailForm: import("@angular/forms").FormGroup<{
        name: import("@angular/forms").FormControl<string | null>;
        enabled: import("@angular/forms").FormControl<boolean | null>;
        value: import("@angular/forms").FormControl<number | null>;
        taxCategoryId: import("@angular/forms").FormControl<string | null>;
        zoneId: import("@angular/forms").FormControl<string | null>;
        customerGroupId: import("@angular/forms").FormControl<string | null>;
        customFields: import("@angular/forms").FormGroup<{}>;
    }>;
    taxCategories$: Observable<TaxCategoryFragment[]>;
    groups$: Observable<CustomerGroup[]>;
    readonly updatePermission: Permission[];
    constructor(changeDetector: ChangeDetectorRef, dataService: DataService, formBuilder: FormBuilder, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    saveButtonEnabled(): boolean;
    create(): void;
    save(): void;
    /**
     * Update the form values when the entity changes.
     */
    protected setFormValues(entity: TaxRateFragment, languageCode: LanguageCode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TaxRateDetailComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TaxRateDetailComponent, "vdr-tax-rate-detail", never, {}, {}, never, never, false, never>;
}
