import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { DataService, GetAvailableCountriesQuery, ItemOf, LocalStorageService } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export interface TestAddress {
    city: string;
    province: string;
    postalCode: string;
    countryCode: string;
}
export declare class TestAddressFormComponent implements OnInit, OnDestroy {
    private formBuilder;
    private dataService;
    private localStorageService;
    addressChange: EventEmitter<TestAddress>;
    availableCountries$: Observable<Array<ItemOf<GetAvailableCountriesQuery, 'countries'>>>;
    form: UntypedFormGroup;
    private subscription;
    constructor(formBuilder: UntypedFormBuilder, dataService: DataService, localStorageService: LocalStorageService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TestAddressFormComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TestAddressFormComponent, "vdr-test-address-form", never, {}, { "addressChange": "addressChange"; }, never, never, false, never>;
}
