import { EventEmitter, OnInit } from '@angular/core';
import { CurrencyCode, DataService, LocalStorageService, ProductSelectorSearchQuery } from '@uponcommerce/admin-ui/core';
import * as i0 from "@angular/core";
type SearchItem = ProductSelectorSearchQuery['search']['items'][number];
export interface TestOrderLine {
    id: string;
    name: string;
    preview: string;
    sku: string;
    unitPriceWithTax: number;
    quantity: number;
}
export declare class TestOrderBuilderComponent implements OnInit {
    private dataService;
    private localStorageService;
    orderLinesChange: EventEmitter<TestOrderLine[]>;
    lines: TestOrderLine[];
    currencyCode: CurrencyCode;
    get subTotal(): number;
    constructor(dataService: DataService, localStorageService: LocalStorageService);
    ngOnInit(): void;
    selectResult(result: SearchItem): void;
    private addToLines;
    updateQuantity(): void;
    removeLine(line: TestOrderLine): void;
    private persistToLocalStorage;
    private loadFromLocalStorage;
    static ɵfac: i0.ɵɵFactoryDeclaration<TestOrderBuilderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TestOrderBuilderComponent, "vdr-test-order-builder", never, {}, { "orderLinesChange": "orderLinesChange"; }, never, never, false, never>;
}
export {};
