import { OnInit } from '@angular/core';
import { DataService, GetZoneListDocument, GetZoneListQuery, ItemOf, LanguageCode, ModalService, NotificationService, TypedBaseListComponent } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import { ZoneMemberListComponent } from '../zone-member-list/zone-member-list.component';
import * as i0 from "@angular/core";
export declare const GET_ZONE_LIST: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
export declare class ZoneListComponent extends TypedBaseListComponent<typeof GetZoneListDocument, 'zones'> implements OnInit {
    protected dataService: DataService;
    private notificationService;
    private modalService;
    activeZone$: Observable<ItemOf<GetZoneListQuery, 'zones'> | undefined>;
    activeIndex$: Observable<number>;
    selectedMemberIds: string[];
    zoneMemberList: ZoneMemberListComponent;
    readonly customFields: import("@uponcommerce/admin-ui/core").CustomFieldConfig[];
    readonly filters: import("@uponcommerce/admin-ui/core").DataTableFilterCollection<import("@uponcommerce/admin-ui/core").ZoneFilterParameter>;
    readonly sorts: import("@uponcommerce/admin-ui/core").DataTableSortCollection<import("@uponcommerce/admin-ui/core").ZoneSortParameter, ["createdAt", "updatedAt", "name"]>;
    constructor(dataService: DataService, notificationService: NotificationService, modalService: ModalService);
    ngOnInit(): void;
    setLanguage(code: LanguageCode): void;
    closeMembers(): void;
    addToZone(zone: ItemOf<GetZoneListQuery, 'zones'>): void;
    refreshMemberList(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ZoneListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ZoneListComponent, "vdr-zone-list", never, {}, {}, never, never, false, never>;
}
