import { EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { FormControl } from '@angular/forms';
import { BulkActionLocationId, DataService, GetZoneListQuery, GetZoneMembersQuery, ItemOf, SelectionManager } from '@uponcommerce/admin-ui/core';
import { Observable } from 'rxjs';
import { ZoneMemberControlsDirective } from './zone-member-controls.directive';
import { ZoneMemberListHeaderDirective } from './zone-member-list-header.directive';
import * as i0 from "@angular/core";
export type ZoneMember = {
    id: string;
    name: string;
    code: string;
};
export declare class ZoneMemberListComponent implements OnInit, OnChanges, OnDestroy {
    private dataService;
    locationId: BulkActionLocationId;
    members?: ZoneMember[];
    selectedMemberIds: string[];
    activeZone: ItemOf<GetZoneListQuery, 'zones'>;
    selectionChange: EventEmitter<string[]>;
    headerTemplate: ZoneMemberListHeaderDirective;
    controlsTemplate: ZoneMemberControlsDirective;
    members$: Observable<NonNullable<GetZoneMembersQuery['zone']>['members'] | ZoneMember[]>;
    filterTermControl: FormControl<string | null>;
    filteredMembers$: Observable<ZoneMember[]>;
    totalItems$: Observable<number>;
    currentPage: number;
    itemsPerPage: number;
    selectionManager: SelectionManager<ZoneMember>;
    private membersInput$;
    private activeZoneInput$;
    private destroy$;
    private refresh$;
    constructor(dataService: DataService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    refresh(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ZoneMemberListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ZoneMemberListComponent, "vdr-zone-member-list", never, { "locationId": { "alias": "locationId"; "required": false; }; "members": { "alias": "members"; "required": false; }; "selectedMemberIds": { "alias": "selectedMemberIds"; "required": false; }; "activeZone": { "alias": "activeZone"; "required": false; }; }, { "selectionChange": "selectionChange"; }, ["headerTemplate", "controlsTemplate"], never, false, never>;
}
